<?php
// Return values
$rtn_val = array();
$rtn_val['success'] = false;
// Request validity status
$request_valid = false;
// Validate POST data
if (isset($_POST['prompt'])){
	$request_valid = true;
}
// Process request
if($request_valid){
	try{
		// Load the OpenAI API key
		// Create a text file (name optional) with your OpenAI API Key on the first line. 
		$api_key = file_get_contents('.openai-php-curl-env');
		$data = array(
			"prompt" => $_POST['prompt'],
			"size" => '512x512', //256x256, 512x512, or 1024x1024 pixels
 			"n" => 1, // Number of images
			"response_format" => "b64_json", //url | b64_json. URLs will expire after an hour.
		);
		// cURL processing
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://api.openai.com/v1/images/generations');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
		$headers = array();
		$headers[] = 'Content-Type: application/json';
		$headers[] = 'Authorization: Bearer ' . $api_key;
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		$response_raw = curl_exec($ch);
		if (curl_errno($ch)) {
			error_log('error: ' . curl_error($ch));
		}else{
			//error_log('$response_raw: ' . print_r($response_raw,true));
			// Decode the JSON response
			$jsonResponse = json_decode($response_raw, true);
			if (!isset($jsonResponse['error'])) {
				// The image
				$base64Image = $jsonResponse['data'][0]['b64_json'];
				// The image in the response
				$rtn_val['image'] = $base64Image;
				$rtn_val['success'] = true;
			}
		}
	}catch(Exception $e) {
		$rtn_val['error']['message'] = 'cannot-process-request';
		error_log('error: ' . $rtn_val['error']['message'] );
		error_log('$e: ' . print_r($e, true));
	}
}
//Respond with JSON content
header('Content-Type: application/json');
echo json_encode( $rtn_val );
?>